//
//  CollectionViewController.m
//  tableView_CollectionVew_Btn
//
//  Created by cshl on 16/4/28.
//  Copyright © 2016年 cshl. All rights reserved.
//

#import "CollectionViewController.h"
#import "CollectionViewCell.h"

static NSString *itemID = @"itemID";
@interface CollectionViewController ()<UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout>

@property(nonatomic,strong)UICollectionView *collectionView;
@property(nonatomic,strong)UIButton * testBtn;

@end

@implementation CollectionViewController

- (void)viewDidLoad {
    [super viewDidLoad];
 
 [self.collectionView registerClass:[CollectionViewCell class] forCellWithReuseIdentifier:itemID];
    
}

#pragma mark  ------- UICollectionViewDelegate && UICollectionDataSource ------

-(NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return 2;

}

-(NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section
{
    
    return 20;
}

-(UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath
{

    CollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:itemID forIndexPath:indexPath];
    _testBtn = cell.testBtn;
    cell.backgroundColor = [UIColor lightGrayColor];
    [_testBtn addTarget:self action:@selector(testBtnAction:) forControlEvents:UIControlEventTouchUpInside];

    return cell;
}


//设置item的大小
-(CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    //1为三个item之间的间距
    return CGSizeMake(self.view.frame.size.width/3-1,80);
}

////每组的间距
-(UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{
    
    return UIEdgeInsetsMake(1,0,0,0);
    
}

//item之间的左右间距
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section
{
    return 0.0f;
}


//item之间的上下间距
- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section
{
    return 2.0f;
}

//点击item
-(void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    
    NSLog(@"%ld,%ld",indexPath.section,indexPath.item);
    
    
}


-(void)testBtnAction:(UIButton *)sender
{

    //获取父类view
    UIView *senderView = [sender superview];
    
    //获取cell
    CollectionViewCell *cell = (CollectionViewCell*)[senderView superview];
    NSIndexPath *indexpath = [self.collectionView indexPathForCell:cell];
    NSInteger item = indexpath.row;
    NSInteger section = indexpath.section;
    
    //获取cell对应的indexpath;
    NSIndexPath *indexPath1 = [NSIndexPath indexPathForRow:item inSection:section];
    
    NSLog(@"indexPath1.section: %ld,indexPath1.row: %ld",indexPath1.section,indexPath1.item);


}


-(UICollectionView *)collectionView
{
    if (!_collectionView) {
        UICollectionViewFlowLayout *flowLayout = [[UICollectionViewFlowLayout alloc] init];
        flowLayout.scrollDirection = UICollectionViewScrollDirectionVertical;
        _collectionView = [[UICollectionView alloc] initWithFrame:CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height) collectionViewLayout:flowLayout];
        _collectionView.dataSource=self;
        _collectionView.delegate=self;
        _collectionView.backgroundColor=[UIColor clearColor];
        _collectionView.showsVerticalScrollIndicator=NO;
        [self.view addSubview:_collectionView];
        
    }

    return _collectionView;
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];

}



@end
