//
//  TableViewController.m
//  tableView_CollectionVew_Btn
//
//  Created by cshl on 16/4/28.
//  Copyright © 2016年 cshl. All rights reserved.
//

#import "TableViewController.h"
#import "TableViewCell.h"

static NSString *cellID=@"cellID";
@interface TableViewController ()<UITableViewDelegate,UITableViewDataSource>

@property(nonatomic,strong)UITableView * tableView;
@property(nonatomic,strong)UIButton *testBtn;

@end

@implementation TableViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self.tableView registerClass:[TableViewCell class] forCellReuseIdentifier:cellID];
}

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 2;

}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 10;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    TableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:cellID forIndexPath:indexPath];
    _testBtn = cell.testBtn;

    [_testBtn addTarget:self action:@selector(testBtnAction:) forControlEvents:UIControlEventTouchUpInside];
  
    return cell;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
   
    return 100;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
  
    NSLog(@"indexPath.section: %ld,indexPath.row: %ld",indexPath.section,indexPath.row);

}

#pragma  mark   ----- BtnAction -----

-(void)testBtnAction:(UIButton *)sender
{
    //获取父类view
    UIView *senderView = [sender superview];
    
    //获取cell
    TableViewCell *cell = (TableViewCell*)[senderView superview];
    NSIndexPath *indexpath = [self.tableView indexPathForCell:cell];
    NSInteger row = indexpath.row;
    NSInteger section = indexpath.section;
    
    //获取cell对应的indexpath; 
    NSIndexPath *indexPath1 = [NSIndexPath indexPathForRow:row inSection:section];
    
    NSLog(@"indexPath1.section: %ld,indexPath1.row: %ld",indexPath1.section,indexPath1.row);

}




#pragma  mark   ------ 懒加载 -----
-(UITableView *)tableView
{
    if (!_tableView) {
        _tableView = [[UITableView alloc]initWithFrame:CGRectMake(0,0,self.view.frame.size.width, self.view.frame.size.height) style:UITableViewStylePlain];
        _tableView.delegate=self;
        _tableView.dataSource=self;
        [self.view addSubview:_tableView];
    }

    return _tableView;
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    
    

}



@end
